#!/usr/bin/perl -w

###########################################################################
#
# toutf8.pl -- converts to utf8
#
# Copyright (C) 1999 DigiLib Systems Limited, NZ.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
###########################################################################

BEGIN {
    die "GSDLHOME not set\n" unless defined $ENV{'GSDLHOME'};
    unshift (@INC, "$ENV{'GSDLHOME'}/perllib");
}

use unicode;
use multiread;
use parsargv;


$encoding = "utf8";
if (!parsargv::parse(\@ARGV, 
		     'unicode', \$unicode,
		     'iso_8859_1', \$iso_8859_1,
		     'iso_8859_6', \$iso_8859_6,
		     'windows_1256', \$windows_1256,
		     'gb', \$gb)) {
    print STDERR "\n  usage: $0 [options]\n\n";
    print STDERR "  options:\n";
    print STDERR "   -unicode      input is in utf-8 or unicode (default)\n";
    print STDERR "   -iso_8859_1   input is in extended ascii (ISO-8859-1 Latin 1)\n";
    print STDERR "   -iso_8859_6   input is in 8 bit Arabic (ISO-8859-6)\n";
    print STDERR "   -windows_1256 input is in Windows 1256 (Arabic)\n";
    print STDERR "   -gb           input is in GB or GBK (simplified Chinese)\n\n";
    die "\n";
}

$encoding = "utf8" if $unicode;
$encoding = "iso_8859_1" if $iso_8859_1;
$encoding = "iso_8859_6" if $iso_8859_6;
$encoding = "windows_1256" if $windows_1256;
$encoding = "gb" if $gb;

$reader = new multiread ();
$reader->set_handle ('main::STDIN');
$reader->set_encoding ($encoding);
$line = "";
while (defined ($line = $reader->read_line())) {
    print $line;
}
